from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, String, Boolean, File

Tripaille_Db_Index_V0_1_0 = CommandToolBuilder(tool="tripaille_db_index", base_command=["tripaille", "db", "index"], inputs=[ToolInput(tag="in_mode", input_type=Int(optional=True), prefix="--mode", doc=InputDocumentation(doc="Indexing mode: 'website' to index the website ,\n'nodes' for the website nodes, 'entities' for the\nwebsite entities (Tripal 3), 'table' to index a single\ntable, 'gene' to build a Gene search index (Tripal 3\nonly) (default: website) ('website' default to 'nodes'\nfor Tripal 2, 'entities' for Tripal 3)  [default:\nwebsite]")), ToolInput(tag="in_table", input_type=String(optional=True), prefix="--table", doc=InputDocumentation(doc="Table to index (only in 'table' mode)")), ToolInput(tag="in_index_name", input_type=String(optional=True), prefix="--index_name", doc=InputDocumentation(doc="Index name (only in 'table' mode)")), ToolInput(tag="in_queues", input_type=Int(optional=True), prefix="--queues", doc=InputDocumentation(doc="Number of indexing task queues (Tripal 2 only)\n[default: 10]")), ToolInput(tag="in_fields", input_type=Boolean(optional=True), prefix="--fields", doc=InputDocumentation(doc="Fields to index (only in 'table' mode), syntax:\n<field_name>|<field_type>, field_type should be one of\n'string' (Tripal2), 'text' (Tripal3), 'keyword',\n'date', 'long', 'double', 'boolean', 'ip', 'object',\n'nested', 'geo_point', 'geo_shape', or 'completion'")), ToolInput(tag="in_links", input_type=Int(optional=True), prefix="--links", doc=InputDocumentation(doc="List of links to show to users, syntax: <column-where-\nto-show-the-link>|</your/url/[any-column-name]>\n(Tripal 2 only)")), ToolInput(tag="in_tokenizer", input_type=String(optional=True), prefix="--tokenizer", doc=InputDocumentation(doc="Tokenizer to use (only in 'table' mode) (one of\n'standard', 'letter', 'lowercase', 'whitespace',\n'uax_url_email', 'classic', 'ngram', 'edge_ngram',\n'keywordx', 'pattern', or 'path_hierarchy';\ndefault='standard')  [default: standard]")), ToolInput(tag="in_token_filters", input_type=Int(optional=True), prefix="--token_filters", doc=InputDocumentation(doc="Token filters (Tripal 3 only) (only in 'table' mode)\n(available filters are 'standard', 'asciifolding',\n'length', 'lowercase', 'uppercase') (Default to\n['standard', 'lowercase'])")), ToolInput(tag="in_exposed", input_type=Boolean(optional=True), prefix="--exposed", doc=InputDocumentation(doc="'Expose the index (read-only) to other websites")), ToolInput(tag="in_index_url", input_type=File(optional=True), prefix="--index_url", doc=InputDocumentation(doc="In order for other sites to link back to your results\npage, you must specify a path where the form for this\nindex can be reached")), ToolInput(tag="in_job_name", input_type=String(optional=True), prefix="--job_name", doc=InputDocumentation(doc="Name of the job")), ToolInput(tag="in_no_wait", input_type=Boolean(optional=True), prefix="--no_wait", doc=InputDocumentation(doc="Do not wait for job to complete"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Tripaille_Db_Index_V0_1_0().translate("wdl", allow_empty_container=True)

